/********************************************************************

    stl.h

    C++ compiler specific 

********************************************************************/


#ifndef stl_h
#define stl_h


// *** Microsoft Visual C++ specific ***

#ifdef _MSC_VER

// The MS VC++ 6.0 debugger can't handle symbols more than 255 characters long.
// STL often creates symbols longer than that.
// When symbols are longer than 255 characters, the warning is disabled.

#pragma warning(disable:4786)

#endif


#include <string>
#include <iostream>
#include <strstream>
#include <fstream>
#include <map>
#include <deque>
#include <list>
#include <vector>
#include <stack>
#include <algorithm>


class AutomaticFlag 
{ 
  protected: 

    bool& flag;
    AutomaticFlag ();

  public :

    AutomaticFlag ( bool& _flag );
   ~AutomaticFlag ();
};


inline AutomaticFlag::AutomaticFlag ( bool& _flag )
: flag(_flag)
{ flag = true; }

inline AutomaticFlag::~AutomaticFlag ()
{ flag = false; }





#endif
