/********************************************************************

    project C-Control II Compiler

    identifier.h

********************************************************************/

#ifndef identifier_h
#define identifier_h


#include "classlib/classlib.h"


typedef Branch<std::string, Virtual::Pointer> Identifier;
void getFullName ( Identifier* identifier, std::string& name );


//---------------------------------
  class Identified : public Virtual
//---------------------------------
{
  protected:
  
    int classid;
    Identifier* identifier;
    unsigned lino;
    short int used :1;
    short int secret :1;

  public:  

    Identified ();
    void destroy ();

    void init ( unsigned _lino, Identifier* _identifier, int _classid = -1 );
    Identifier* getIdentifier ();
    unsigned getDeclarationLineNumber ();

    virtual void use ();
    bool isUsed () const;

    void declareSecret ();
    bool isSecret () const;

    int what () const;

    virtual void dump( std::ostream& os );
};


inline Identified::Identified ()
: identifier(0), classid(-1), used(false), secret(false)
{}

inline Identifier* Identified::getIdentifier ()
{ return identifier; }


inline unsigned Identified::getDeclarationLineNumber ()
{ return lino; }


inline void Identified::use ()
{ used = true; }

inline bool Identified::isUsed () const
{ return used != 0; }

inline void Identified::declareSecret ()
{ secret = true; }

inline bool Identified::isSecret () const
{ return secret != 0; }

inline int Identified::what () const
{ return classid; }




#endif

