/********************************************************************

    C-Control II Compiler

    text.cpp

********************************************************************/


#include "text.h"

namespace Text
{

typedef const char* const ptxt;


// *** standard text ***

const ptxt txt [] =
{
//  #ifdef GERMAN
//    #include "text/german.txt"
//  #else
      #include "text/english.txt"
//  #endif
};


static std::string text;

//-------------------------------
  const std::string& get( ID id )
//-------------------------------
{
  text = txt[id];
  return text;
}


// *** symbol text ***

#define NO_TEXT ""

const ptxt symtxt [] =
{
  NO_TEXT, NO_TEXT, NO_TEXT, NO_TEXT, NO_TEXT,

  "{" , "}" , "(" , ")" , "[" , "]",
  ";", ":", ".", "...", ",", "?", "=",
  "==", "!=", ">", "<", ">=", "<=", 
  "+", "-", "*", "/", 

  NO_TEXT, 
  "mod", "not", "and", "nand", "or", "nor", "xor", "shl", "shr",
  "inline", "module", "thread", "function", "returns", "return",
  "const", "byte", "int", "long", "float", "string", "type",
  "run", "halt", "resume", "sleep", "wait", "capture", "release", "reset", "yield", "quit",
  "if", "else", "loop", "for", "while", "do", "step", "break", "continue"
};


//--------------------------------------
  const std::string& get( Token::ID id )
//--------------------------------------
{
  switch ( id )
  {
    case Token::NONE        : text = get(KEYWORD); break;
    case Token::LINE_FEED   : text = get(LINE_FEED); break;
    case Token::END_OF_FILE : text = get(END_OF_FILE); break;
    case Token::IDENTIFIER  : text = get(IDENTIFIER); break;

    default: text = symtxt[id];
  }

  return text;
}

}