/********************************************************************

    C-Control II Compiler

    text.h

********************************************************************/


#ifndef text_h
#define text_h


#include "classlib/classlib.h"

#include "token.h"

namespace Text
{


typedef enum   
{
  HEADLINE,
  COMPILING,
  READY,
  ERRORS,
  OR,

  INVALID_SYMBOL,
  EXPECTED,
  UNEXPECTED,
  UNKNOWN,
  
  LINE_FEED,
  END_OF_FILE,
  KEYWORD,
  LITERAL_INT,
  LITERAL_FLOAT,
  LITERAL_CHAR,
  LITERAL_STRING,
  IDENTIFIER, 
  THREAD_IDENTIFIER, 
  FUNCTION_IDENTIFIER, 
  TYPE_IDENTIFIER, 
  CONSTANT_IDENTIFIER, 
  VARIABLE_IDENTIFIER,

  MULTIPLE_DECLARATION,
  SIMPLE_TYPE,
  TYPE_MISMATCH,
  CONSTANT_EXPRESSION,
  RECURSIVE_TYPE,

  DIV_ZERO,

  ARRAY_TOO_BIG,

  NO_MAIN_THREAD,
  TOO_MANY_THREADS,
  TOO_MUCH_CONSTANT_DATA,
  TOO_MUCH_VARIABLE_DATA,
  PROGRAM_TOO_BIG,

  FATAL_ERROR,
  VMC_READY

} ID;

const std::string& get( ID id );
const std::string& get( Token::ID od );

}


#endif