/********************************************************************

    C-Control II Compiler

    token.h

********************************************************************/


#ifndef token_h
#define token_h


//------------
  struct Token 
//------------
{
  typedef enum
  {
    NONE, INVALID, UNEXPECTED_END_OF_LINE, LINE_FEED, END_OF_FILE,

    LEFT_BRACE, RIGHT_BRACE,
    LEFT_PARENTHESIS, RIGHT_PARENTHESIS,
    LEFT_BRACKET, RIGHT_BRACKET,

    SEMICOLON, COLON, DOT, ELLIPSE, COMMA, QUESTIONMARK, 
    ASSIGN,
    EQUAL, NOTEQUAL, HIGHER, LOWER, HIGHERSAME, LOWERSAME,
    PLUS, MINUS, MUL, DIV, MOD,
  
  KEYWORDS_BEGIN,
  
    NOT, AND, NAND, OR, NOR, XOR, SHL, SHR,
    INLINE, MODULE, THREAD, FUNCTION, RETURNS, RETURN,
    CONSTANT, BYTE, INT, LONG, FLOAT, STRING, TYPE,
    RUN, HALT, RESUME, SLEEP, WAIT, CAPTURE, RELEASE,
    RESET, YIELD, QUIT,
    IF, ELSE, LOOP, FOR, WHILE, DO, STEP, BREAK, CONTINUE,
  
  KEYWORDS_END,

    LITERAL_INT, LITERAL_FLOAT, LITERAL_CHAR, LITERAL_STRING,

    IDENTIFIER,

    _NUMBER

  } ID;


  ID   id;
  long value;
};



#endif